#!/bin/bash
echo `cppcheck --version`

LOG_FILE=cppcheck_cdo.txt

SCRIPT_DIR=$(dirname "$0")
case $SCRIPT_DIR in
    "/"*)
        ;;
    ".")
        SCRIPT_DIR=$(pwd)
        ;;
    *)
        SCRIPT_DIR=$(pwd)/$(dirname "$0")
        ;;
esac

TOPDIR="$SCRIPT_DIR/.."
echo $TOPDIR

# --inconclusive  --template='{file}:{line},{severity},{id},{message}'
# set -x
echo "" > ${LOG_FILE}
dirname=$TOPDIR/src
cppcheck --std=c++14  --force --enable=all --inline-suppr --template='{file}:{line},{severity},{id},{message}' \
         -I${TOPDIR}/build/gnu/src -I${TOPDIR}/libcdi/src \
         -DHAVE_CONFIG_H  \
         "$dirname" >>${LOG_FILE} 2>&1
#

#
echo "LOG_FILE: ${LOG_FILE}"
#
for PATTERN in warning error performance; do
    grep $PATTERN ${LOG_FILE}
done
echo "grep -v HAVE_CONFIG_H  ${LOG_FILE} | more"
